/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: kjoy.h,v 1.2 2000/11/04 21:16:58 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_KJOY_H
#define _XZX_KJOY_H
#include "resource.h"
#include "io.h"
#ifdef JOY
#include "joystick.h"
#endif
#ifdef JOY
#define INBYTE_KJOY(port,res,label) \
	{																															\
		if (((port) & B_KEMPSTON) == (P_KEMPSTON & B_KEMPSTON))																	\
		{																														\
			(res) = CFGGET(joy) > 0 ? (uns8)JoyRead() : KjoyPort;																\
																																\
														\
			(res) &= B_RIGHT | B_LEFT | B_DOWN | B_UP | B_FIRE;																	\
			goto label;																											\
		}																														\
	}
#else
#define INBYTE_KJOY(port,res,label) \
	{																															\
		if (((port) & B_KEMPSTON) == (P_KEMPSTON & B_KEMPSTON))																	\
		{																														\
														\
			(res) = KjoyPort & (B_RIGHT | B_LEFT | B_DOWN | B_UP | B_FIRE);														\
			goto label;																											\
		}																														\
	}
#endif
extern uns8 KjoyPort;
#endif
