/********************************************************************************
 * Copyright (c) Des Herriott 1993 - 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation
 * for any purpose is hereby granted without fee, provided that the above
 * copyright notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation, and that the name
 * of the copyright holder not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.  The
 * copyright holder makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Des Herriott
 *          Erik Kunze
 *
 * $Id: mem.h,v 4.35 2000/07/24 17:28:44 erik Rel $
 *******************************************************************************/
#ifndef _XZX_MEM_H
#define _XZX_MEM_H
#include "cpu.h"
#define XZX_PAGESIZE	16384
enum {
	SP48ROM,
	SP128ROM0, SP128ROM1,
	SP3ROM0, SP3ROM1, SP3ROM2, SP3ROM3,
#ifdef XZX_PENTAGON
	PENTROM0, PENTROM1, PENTROM2,
#endif
#ifdef XZX_SCORPION
	SCORROM0, SCORROM1, SCORROM2, SCORROM3,
#endif
#ifdef XZX_DIDAKTIK
	DIDROM0, DIDROM1,
#endif
#ifdef XZX_IF1
	IF1ROM,
#endif
#ifdef XZX_MF
	MF128ROM,
	MF3ROM,
#endif
#ifdef XZX_TRDOS
	TRDOSROM,
#endif
#ifdef XZX_MGT
	MGTROM,
#endif
	RAM0, RAM1, RAM2, RAM3, RAM4, RAM5, RAM6, RAM7,
#ifdef XZX_SCORPION
	RAM8, RAM9, RAMA, RAMB, RAMC, RAMD, RAME, RAMF,
#endif
	NPAGES
};
#define MFRAM			RAM0
#define MGTRAM			RAM0
#define VPAGE(addr)		((addr) >> 13)
#define RPAGE(addr)		(RealPageNumbers[VPAGE(addr)])
#define MEM(addr)		(TheMemory[VPAGE(addr)][(addr) & 0x1fff])
#define READ_ONLY(addr)	(RPAGE(addr) < RAM0)
extern void MemoryInit(void);
extern int LoadRomImage(char *, int, int);
extern int GetRomChecksum(int , int);
extern uns8 *TheMemory[8];
extern int RealPageNumbers[8];
extern uns8 *RealMemory[NPAGES];
#endif
