/*********************************************************************************************************************************
 * Copyright (c) Des Herriott 1993 - 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Des Herriott
 *          Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifdef XBELL_AUDIO
#ifndef lint
static char beep_c[] = "$Id: beep.c,v 4.18 2000/11/18 18:45:50 erik Rel $";
#endif
#include <X11/Xlib.h>
#include "debug.h"
#include "resource.h"
#include "util.h"
#include "xwin.h"
#include "beep.h"
#ifdef DEBUG
#define DEB(x)							{ if ((CFGGET(debug) & D_AUDIO) != 0) { x } }
#else
#define DEB(x)
#endif
void
BeepOut(unsigned int freq, unsigned int duration)
{
	XKeyboardState kbs, oldKbs;
	XwinData *xdp = &XwinDatas;
	if (CFGGET(audio) == 0 || CFGGET(audioVolume) == 0 || CFGGET(fastmode) != 0)
	{
		return;
	}
	DEB(Msg(M_DEBUG, "BEEP: freq = %d Hz, time = %d ms", freq, duration););
	XGetKeyboardControl(xdp->display, &oldKbs);
	kbs.bell_pitch = freq;
	kbs.bell_duration = duration;
	kbs.bell_percent = CFGGET(audioVolume);
	XChangeKeyboardControl(xdp->display, KBBellPitch | KBBellDuration | KBBellPercent, (XKeyboardControl *)&kbs);
	XBell(xdp->display, 0);
	XChangeKeyboardControl(xdp->display, KBBellPitch | KBBellDuration | KBBellPercent, (XKeyboardControl *)&oldKbs);
	XFlush(xdp->display);
}
#endif
