/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: tape.h,v 1.2 2000/07/18 12:16:20 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_TAPE_H
#define _XZX_TAPE_H
#define LOAD_BPT						0xfc
#define SAVE_BPT						0xfd
#define TS_ERRIN						0x00001
#define TS_ERROUT						0x00002
#define TS_ENDIN						0x00004
#define TS_ENDOUT						0x00008
#define TS_PLAY							0x00010
#define TS_QUICKLOAD					0x00100
#define TS_FASTLOAD						0x00200
#define TS_AUTOSTOP						0x00400
#define TS_NOISE						0x00800
#define TS_TAPIN						0x01000
#define TS_VOCIN						0x02000
#define TS_TZXIN						0x04000
#define TS_TAPOUT						0x10000
#define GET1(a,o)						(a[o])
#define GET2(a,o)						(a[o] + (a[o+1] << 8))
#define GET3(a,o)						(a[o] + (a[o+1] << 8) + (a[o+2] << 16))
#define GET4(a,o) 						(a[o] + (a[o+1] << 8) + (a[o+2] << 16) + (a[o+3] << 24))
typedef struct _tapeRecord {
	uns8 *pos;
	char *str;
} TapeRecord;
extern void TapeInit(void);
extern unsigned int TapeGetState(void);
extern void TapeSetState(unsigned int);
extern unsigned int TapeInGetBlock(void);
extern int TapeInSetBlock(unsigned int);
extern unsigned int TapeInGetBlocks(void);
extern int TapeInNextBlock(void);
extern TapeRecord *TapeInGetRecord(unsigned int);
extern unsigned int TapeInSetRecord(TapeRecord *);
extern const char *TapeInGetInfo(unsigned int);
extern const char *TapeInGetName(void);
extern void TapeInReadBlock(void);
extern int TapeInAttach(char *);
extern void TapeInDetach(void);
extern void TapeInPlay(void);
extern void TapeInStop(void);
extern uns8 (*TapeInGetBit)(void);
extern const char *TapeOutGetName(void);
extern void TapeOutWriteBlock(void);
extern int TapeOutAttach(char *);
extern void TapeOutDetach(void);
#endif
