/*********************************************************************************************************************************
 * Copyright (c) Des Herriott 1993 - 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Ian Collier, Des Herriott
 *          Erik Kunze
 *
 * $Id: resource.h,v 4.45 2000/11/18 16:13:53 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_RESOURCE_H
#define _XZX_RESOURCE_H
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
typedef struct _resourceData {
	char *libDir;
	char *infoDir;
	char *pokeDir;
	int quiet;
	int core;
	int monocrome;
	int private;
	int xsync;
#ifdef DEBUG
	unsigned int debug;
#endif
	int machine;
	int speed;
	int fastmode;
	int warn48;
	int scale;
	int refresh;
	int cache;
#ifndef NO_ED_TRAPS
	int tapeQuickload;
#endif
	int tapeFastload;
	int tapeAutostop;
#ifdef REAL_AUDIO
	int tapeNoise;
#endif
	KeySym joyKeys[5];
#ifdef JOY
	int joy;
	char *joyDev;
	int joyTolerance;
	int joyAutofire;
	int joyJuggle;
#endif
#ifdef AUDIO
	int audio;
#ifdef REAL_AUDIO
	char *audioDev;
	int audioSample;
	int audioStereo;
#endif
#ifdef XBELL_AUDIO
	unsigned int audioVolume;
#endif
#endif
	char *sp48Rom;
	char *sp128Rom;
	char *sp3Rom;
	char *sp3Disks[2];
#ifdef XZX_PENTAGON
	char *pentagonRom;
#endif
#ifdef XZX_SCORPION
	char *scorpionRom;
#endif
#ifdef XZX_DIDAKTIK
	char *didaktikRom;
	char *didaktikDisks[2];
#endif
#ifdef XZX_IF1
	int if1;
	char *if1Rom;
	int if1Crlf;
	int if1Strcr;
	char *if1Carts[IF1_DRIVES];
#endif
#ifdef XZX_MF
	int mf1;
	char *mf1Rom;
	int mf128;
	char *mf128Rom;
	int mf3;
	char *mf3Rom;
#endif
#ifdef XZX_TRDOS
	int	trdos;
	char *trdosRom;
	char *trdosDisks[4];
#endif
#ifdef XZX_MGT
	int	mgt;
	char *mgtRom;
	char *mgtDisks[2];
#endif
#ifdef XZX_KMOUSE
	int kmouse;
	int kmouseGrab;
#endif
} ResourceData;
#define CFGGET(x)						ResourceDatas.x
#define CFGSET(x,y)						ResourceDatas.x = y
#define joyUp							joyKeys[0]
#define joyDown							joyKeys[1]
#define joyLeft							joyKeys[2]
#define joyRight						joyKeys[3]
#define joyFire							joyKeys[4]
extern void ResourceRead(int *, char **);
extern int ResourceWrite(void);
extern ResourceData ResourceDatas;
extern XrmOptionDescRec ResourceOptions[];
extern Cardinal ResourceOptionsCount;
#endif
