/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: ui.h,v 1.1 2000/06/28 20:00:55 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_UI_H
#define _XZX_UI_H
#include <Xm/Xm.h>
enum { DIALOG_NONE = 0, DIALOG_CANCEL = 1, DIALOG_OK = 2 };
enum { DIALOG_ERROR, DIALOG_INFO, DIALOG_MSG, DIALOG_ASK, DIALOG_WARN, DIALOG_WORK };
extern void UiInit(int);
extern int UiEnter(void);
extern int UiLeave(void);
extern int UiIsActive(void);
extern Widget UiCreateFrame(Widget, const char *);
extern Widget UiCreateDialog(int *);
extern void UiShowDialog(Widget, int *);
extern void UiShowAbout(void);
extern int UiShowMessage(int, const char *, const char *, const char *, int);
extern int UiShowTextFile(const char *, XtCallbackProc, XtPointer);
extern char *UiFileSelector(const char *, int, int *);
extern int UiBrowseList(const char *, char **, int, int);
extern void UiFixiateListWidth(Widget, Widget, int);
#endif
